/*
 *   Copyright (C) 2011-2012, Michael Anders, FH-Wedel
 *
 *  This file is part of the ECC-Implementation "Academic Signature"
 *  Maintainer: Michael Anders
 *
 *  All rights reserved.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */
 

#ifndef LOADSAVE_ELL_PUB_H
#define LOADSAVE_ELL_PUB_H

//(*Headers(LoadSave_ell_pub)
#include <wx/sizer.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/button.h>
#include <wx/dialog.h>
//*)

#include "globals.h"
#include "elliptic1.h"

class LoadSave_ell_pub: public wxDialog
{
	public:

		LoadSave_ell_pub(wxWindow* parent,wxWindowID id=wxID_ANY,const wxPoint& pos=wxDefaultPosition,const wxSize& size=wxDefaultSize);
		virtual ~LoadSave_ell_pub();

		//(*Declarations(LoadSave_ell_pub)
		wxButton* Button4;
		wxTextCtrl* ax_ctrl;
		wxStaticText* StaticText2;
		wxButton* Button1;
		wxStaticText* StaticText6;
		wxStaticText* StaticText1;
		wxStaticText* StaticText3;
		wxButton* Button2;
		wxTextCtrl* ay_ctrl;
		wxTextCtrl* name_ctrl;
		wxButton* Button3;
		wxStaticText* StaticText5;
		wxTextCtrl* domnam_ctrl;
		wxTextCtrl* id_ctrl;
		wxStaticText* StaticText4;
		//*)

	protected:

		//(*Identifiers(LoadSave_ell_pub)
		static const long ID_BUTTON4;
		static const long ID_STATICTEXT1;
		static const long ID_STATICTEXT2;
		static const long ID_STATICTEXT3;
		static const long ID_STATICTEXT4;
		static const long ID_TEXTCTRL1;
		static const long ID_TEXTCTRL2;
		static const long ID_TEXTCTRL3;
		static const long ID_STATICTEXT5;
		static const long ID_TEXTCTRL4;
		static const long ID_STATICTEXT6;
		static const long ID_TEXTCTRL5;
		static const long ID_BUTTON1;
		static const long ID_BUTTON2;
		static const long ID_BUTTON3;
		//*)

	private:

	    el_pub loky;

		//(*Handlers(LoadSave_ell_pub)
		void OnSaveLocal(wxCommandEvent& event);
		void OnGetLocal(wxCommandEvent& event);
		void OnImportFile(wxCommandEvent& event);
		void OnExit(wxCommandEvent& event);
		//*)

		DECLARE_EVENT_TABLE()
};

#endif
